import java.util.LinkedList;
import java.util.NoSuchElementException;

public class Node {

	private Node left;
	private int key;
	private Object value;
	private Node right;

	public Node(Node left, int key, Object value, Node right) {
		this.left = left;
		this.key = key;
		this.value = value;
		this.right = right;
	}

	public Node(int key, Object value) {
		this.key = key;
		this.value = value;
	}

	public Object getValue() {
		return this.value;
	}

	public int getKey() {
		return this.key;
	}

	public Node getLeft() {
		return this.left;
	}

	public Node getRight() {
		return this.right;
	}

	public Object findElement(int key) throws NoSuchElementException {
		if (key == this.key) {
			return this.value;
		}
		if (this.left != null) {
			try {
				return this.left.findElement(key);
			} catch (NoSuchElementException e) {
				// Element konnte nicht im linken Teilbaum gefunden werden
			}
		}
		if (this.right != null) {
			try {
				return this.right.findElement(key);
			} catch (NoSuchElementException e) {
				// Element konnte nicht im rechten Teilbaum gefunden werden
			}
		}
		throw new NoSuchElementException();
	}

	public void buildList(LinkedList<Object> res) {
		res.addLast(this.value);
		if (this.left != null) {
			this.left.buildList(res);
		}
		if (this.right != null) {
			this.right.buildList(res);
		}
	}
}
