import java.awt.Container;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.LinkedList;
import java.util.NoSuchElementException;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextArea;

public class TreeFrame extends JFrame implements ActionListener {
	private JButton elementfindenButton;
	private JButton baumumwandelnButton;

	private JTextArea ausgabeBereich;

	public static final BinTree tree = new BinTree(new BinTree(7, "World"), 2, "Hello",
			new BinTree());

	/**
	 * In diesem Programmstück wird das Fenster erzeugt
	 */
	public TreeFrame() {
		/* In der Kopfleiste des Fenster steht "TreeFrame" */
		this.setTitle("TreeFrame");

		/* Das Fenster ist 500 Pixel breit und 200 Pixel hoch. */
		this.setSize(500, 200);

		/* Hier werden alle Buttons erzeugt. */
		this.elementfindenButton = new JButton(
				"Finde Element zu einem gegebenen key");
		this.baumumwandelnButton = new JButton(
				"Umwandlung des Baums in eine Liste");

		/* Hier wird der Ausgabe-Bereich erzeugt. */
		this.ausgabeBereich = new JTextArea(10, 100);

		/* Hier werden alle Buttons zusammengruppiert. */
		JPanel buttonPanel = new JPanel();
		buttonPanel.setLayout(new GridLayout(2, 1));
		buttonPanel.add(this.elementfindenButton);
		buttonPanel.add(this.baumumwandelnButton);

		/*
		 * Der ContentPane ist der Ausschnitt des Fensters, auf dem Widgets d.h.
		 * Interaktionselemente (wie eine TextArea oder ein Button) platziert
		 * werden können.
		 */
		Container contentPane = this.getContentPane();
		contentPane.setLayout(new GridLayout(2, 1));
		/* Hier wird die Gruppe von Buttons platziert. */
		contentPane.add(buttonPanel);
		/* Hier wird der Ausgabebereich platziert. */
		contentPane.add(this.ausgabeBereich);

		/*
		 * Hier wird der TreeFrame als Listener für Knopfdruck-Ereignisse bei
		 * jedem der Buttons registriert.
		 */
		this.elementfindenButton.addActionListener(this);
		this.baumumwandelnButton.addActionListener(this);

		/*
		 * Wird das Fenster geschlossen (d.h. auf X gedrückt), wird mit Hilfe
		 * dieser Programmzeile auch unser Programm ordnungsgemäß beendet.
		 */
		this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		// je nach Button entsprechende Methode ausführen
		Object source = e.getSource();
		if (source == this.elementfindenButton) {
			this.findeElement();
		} else if (source == this.baumumwandelnButton) {
			this.umwandelnBaum();
		}
	}

	/**
	 * implementiert die Funktionalität des Buttons zum Finden eines Elements
	 */
	private void findeElement() {
		String einlesenKey = JOptionPane
				.showInputDialog("Key zu gesuchtem Element eingeben: ");
		int key = Integer.parseInt(einlesenKey);

		this.ausgabeBereich.setText("");
		String gefundenesElement = "";
		try {
			gefundenesElement = tree.findElement(key).toString();
			this.ausgabeBereich.setText(gefundenesElement);
		} catch (NoSuchElementException e) {
			this.ausgabeBereich.setText("Ein Element mit diesem Schl�ssel ist"
					+ " im vorgegebenen Baum nicht vorhanden.");
		}
	}

	/**
	 * implementiert die Funktionalität des Buttons zum Umwandeln des Baums in
	 * eine Liste
	 */
	private void umwandelnBaum() {
		LinkedList<Object> ausgabeliste = tree.toList();

		this.ausgabeBereich.setText("Der Baum als Liste: \n");
		for (Object knoten : ausgabeliste) {
			this.ausgabeBereich.append(knoten.toString() + "\n");
		}
	}
}
